import SVGSVGElement from '../nodes/svg-svg-element/SVGSVGElement.js';
import SVGAnimateElement from '../nodes/svg-animate-element/SVGAnimateElement.js';
import SVGAnimateMotionElement from '../nodes/svg-animate-motion-element/SVGAnimateMotionElement.js';
import SVGAnimateTransformElement from '../nodes/svg-animate-transform-element/SVGAnimateTransformElement.js';
import SVGCircleElement from '../nodes/svg-circle-element/SVGCircleElement.js';
import SVGClipPathElement from '../nodes/svg-clip-path-element/SVGClipPathElement.js';
import SVGDefsElement from '../nodes/svg-defs-element/SVGDefsElement.js';
import SVGDescElement from '../nodes/svg-desc-element/SVGDescElement.js';
import SVGEllipseElement from '../nodes/svg-ellipse-element/SVGEllipseElement.js';
import SVGFEBlendElement from '../nodes/svg-fe-blend-element/SVGFEBlendElement.js';
import SVGFEColorMatrixElement from '../nodes/svg-fe-color-matrix-element/SVGFEColorMatrixElement.js';
import SVGFEComponentTransferElement from '../nodes/svg-fe-component-transfer-element/SVGFEComponentTransferElement.js';
import SVGFECompositeElement from '../nodes/svg-fe-composite-element/SVGFECompositeElement.js';
import SVGFEConvolveMatrixElement from '../nodes/svg-fe-convolve-matrix-element/SVGFEConvolveMatrixElement.js';
import SVGFEDiffuseLightingElement from '../nodes/svg-fe-diffuse-lighting-element/SVGFEDiffuseLightingElement.js';
import SVGFEDisplacementMapElement from '../nodes/svg-fe-displacement-map-element/SVGFEDisplacementMapElement.js';
import SVGFEDistantLightElement from '../nodes/svg-fe-distant-light-element/SVGFEDistantLightElement.js';
import SVGFEDropShadowElement from '../nodes/svg-fe-drop-shadow-element/SVGFEDropShadowElement.js';
import SVGFEFloodElement from '../nodes/svg-fe-flood-element/SVGFEFloodElement.js';
import SVGFEFuncAElement from '../nodes/svg-fe-func-a-element/SVGFEFuncAElement.js';
import SVGFEFuncBElement from '../nodes/svg-fe-func-b-element/SVGFEFuncBElement.js';
import SVGFEFuncGElement from '../nodes/svg-fe-func-g-element/SVGFEFuncGElement.js';
import SVGFEFuncRElement from '../nodes/svg-fe-func-r-element/SVGFEFuncRElement.js';
import SVGFEGaussianBlurElement from '../nodes/svg-fe-gaussian-blur-element/SVGFEGaussianBlurElement.js';
import SVGFEImageElement from '../nodes/svg-fe-image-element/SVGFEImageElement.js';
import SVGFEMergeElement from '../nodes/svg-fe-merge-element/SVGFEMergeElement.js';
import SVGFEMergeNodeElement from '../nodes/svg-fe-merge-node-element/SVGFEMergeNodeElement.js';
import SVGFEMorphologyElement from '../nodes/svg-fe-morphology-element/SVGFEMorphologyElement.js';
import SVGFEOffsetElement from '../nodes/svg-fe-offset-element/SVGFEOffsetElement.js';
import SVGFEPointLightElement from '../nodes/svg-fe-point-light-element/SVGFEPointLightElement.js';
import SVGFESpecularLightingElement from '../nodes/svg-fe-specular-lighting-element/SVGFESpecularLightingElement.js';
import SVGFESpotLightElement from '../nodes/svg-fe-spot-light-element/SVGFESpotLightElement.js';
import SVGFETileElement from '../nodes/svg-fe-tile-element/SVGFETileElement.js';
import SVGFETurbulenceElement from '../nodes/svg-fe-turbulence-element/SVGFETurbulenceElement.js';
import SVGFilterElement from '../nodes/svg-filter-element/SVGFilterElement.js';
import SVGForeignObjectElement from '../nodes/svg-foreign-object-element/SVGForeignObjectElement.js';
import SVGGElement from '../nodes/svg-g-element/SVGGElement.js';
import SVGImageElement from '../nodes/svg-image-element/SVGImageElement.js';
import SVGLineElement from '../nodes/svg-line-element/SVGLineElement.js';
import SVGLinearGradientElement from '../nodes/svg-linear-gradient-element/SVGLinearGradientElement.js';
import SVGMarkerElement from '../nodes/svg-marker-element/SVGMarkerElement.js';
import SVGMaskElement from '../nodes/svg-mask-element/SVGMaskElement.js';
import SVGMetadataElement from '../nodes/svg-metadata-element/SVGMetadataElement.js';
import SVGMPathElement from '../nodes/svg-m-path-element/SVGMPathElement.js';
import SVGPathElement from '../nodes/svg-path-element/SVGPathElement.js';
import SVGPatternElement from '../nodes/svg-pattern-element/SVGPatternElement.js';
import SVGPolygonElement from '../nodes/svg-polygon-element/SVGPolygonElement.js';
import SVGPolylineElement from '../nodes/svg-polyline-element/SVGPolylineElement.js';
import SVGRadialGradientElement from '../nodes/svg-radial-gradient-element/SVGRadialGradientElement.js';
import SVGRectElement from '../nodes/svg-rect-element/SVGRectElement.js';
import SVGScriptElement from '../nodes/svg-script-element/SVGScriptElement.js';
import SVGSetElement from '../nodes/svg-set-element/SVGSetElement.js';
import SVGStopElement from '../nodes/svg-stop-element/SVGStopElement.js';
import SVGStyleElement from '../nodes/svg-style-element/SVGStyleElement.js';
import SVGSwitchElement from '../nodes/svg-switch-element/SVGSwitchElement.js';
import SVGSymbolElement from '../nodes/svg-symbol-element/SVGSymbolElement.js';
import SVGTextElement from '../nodes/svg-text-element/SVGTextElement.js';
import SVGTextPathElement from '../nodes/svg-text-path-element/SVGTextPathElement.js';
import SVGTitleElement from '../nodes/svg-title-element/SVGTitleElement.js';
import SVGTSpanElement from '../nodes/svg-t-span-element/SVGTSpanElement.js';
import SVGUseElement from '../nodes/svg-use-element/SVGUseElement.js';
import SVGViewElement from '../nodes/svg-view-element/SVGViewElement.js';

export default interface ISVGElementTagNameMap {
	svg: SVGSVGElement;
	animate: SVGAnimateElement;
	animateMotion: SVGAnimateMotionElement;
	animateTransform: SVGAnimateTransformElement;
	circle: SVGCircleElement;
	clipPath: SVGClipPathElement;
	defs: SVGDefsElement;
	desc: SVGDescElement;
	ellipse: SVGEllipseElement;
	feBlend: SVGFEBlendElement;
	feColorMatrix: SVGFEColorMatrixElement;
	feComponentTransfer: SVGFEComponentTransferElement;
	feComposite: SVGFECompositeElement;
	feConvolveMatrix: SVGFEConvolveMatrixElement;
	feDiffuseLighting: SVGFEDiffuseLightingElement;
	feDisplacementMap: SVGFEDisplacementMapElement;
	feDistantLight: SVGFEDistantLightElement;
	feDropShadow: SVGFEDropShadowElement;
	feFlood: SVGFEFloodElement;
	feFuncA: SVGFEFuncAElement;
	feFuncB: SVGFEFuncBElement;
	feFuncG: SVGFEFuncGElement;
	feFuncR: SVGFEFuncRElement;
	feGaussianBlur: SVGFEGaussianBlurElement;
	feImage: SVGFEImageElement;
	feMerge: SVGFEMergeElement;
	feMergeNode: SVGFEMergeNodeElement;
	feMorphology: SVGFEMorphologyElement;
	feOffset: SVGFEOffsetElement;
	fePointLight: SVGFEPointLightElement;
	feSpecularLighting: SVGFESpecularLightingElement;
	feSpotLight: SVGFESpotLightElement;
	feTile: SVGFETileElement;
	feTurbulence: SVGFETurbulenceElement;
	filter: SVGFilterElement;
	foreignObject: SVGForeignObjectElement;
	g: SVGGElement;
	image: SVGImageElement;
	line: SVGLineElement;
	linearGradient: SVGLinearGradientElement;
	marker: SVGMarkerElement;
	mask: SVGMaskElement;
	metadata: SVGMetadataElement;
	mpath: SVGMPathElement;
	path: SVGPathElement;
	pattern: SVGPatternElement;
	polygon: SVGPolygonElement;
	polyline: SVGPolylineElement;
	radialGradient: SVGRadialGradientElement;
	rect: SVGRectElement;
	script: SVGScriptElement;
	set: SVGSetElement;
	stop: SVGStopElement;
	style: SVGStyleElement;
	switch: SVGSwitchElement;
	symbol: SVGSymbolElement;
	text: SVGTextElement;
	textPath: SVGTextPathElement;
	title: SVGTitleElement;
	tspan: SVGTSpanElement;
	use: SVGUseElement;
	view: SVGViewElement;
}
